<?php include("menu.php"); ?>

<h1>The stylish way of giving presentations</h1>

<p>Impressive is a program that displays presentation slides. But unlike OpenOffice.org Impress or other similar applications, it does so with style. Smooth alpha-blended slide transitions are provided for the sake of eye candy, but in addition to this, Impressive offers some unique tools that are really useful for presentations. <a href="#features">Read below</a> if you want to know more about these features.</p>

<p>Creating presentations for Impressive is very simple: You just need to export a PDF file from your presentation software. This means that you can create slides in the application of your choice and use Impressive for displaying them. If your application does not support PDF output, you can alternatively use a set of pre-rendered image files &ndash; or you use Impressive to make a slideshow with your favorite photos.</p>


<h1>Technology</h1>

<p>Impressive is written in <a href="http://www.python.org/"><strong>Python</strong></a>, a feature-rich interpreted scripting language. Python is available on numerous platforms. Because of this, Impressive works with most operating systems, including Microsoft Windows, Apple Mac OS X, and of course Linux.</p>

<p><a href="http://www.foolabs.com/xpdf/"><strong>Xpdf</strong></a> (preferred) or <a href="http://www.cs.wisc.edu/~ghost/"><strong>GhostScript</strong></a> are used for PDF rendering, and <a href="http://www.opengl.org/"><strong>OpenGL</strong></a> enables hardware acceleration support required for the various graphical effects in Impressive.</p>


<h1><a name="features"></a>Features</h1>

<p>As stated above, Impressive contains some unique features that come in handy when giving presentations:</p>

<div class="feature"><img src="trans.png" />
<h2>Page transitions</h2>
<p>The page transition effects aren't exactly useful, but they are nice to watch and provide a moment of relaxation for both the audience and the presenter :)</p>
</div>

<div class="feature"><img src="oview.png" />
<h2>Overview screen</h2>
<p>Imagine the following common situation: After you finished your presentation, the audience puts questions, and you need to go back to a specific slide to explain some fact in more detail.</p>
<p>In Impressive, you just have to hit the [Tab] key and the current slide will smoothly zoom out, revealing a thumbnail grid of all pages. Now you can select one of the pages, click on it, and watch it zoom back in.</p>
</div>

<div class="feature"><img src="hlbox.png" />
<h2>Highlight boxes</h2>
<p>Maybe you want to focus the attention of your audience on a specific part of the current slide. To accomplish this, you can drag a rectangle on the screen while holding down the left mouse button. After releasing the button, the screen will get dark and blurry &ndash; except for the part you just selected.</p>
<p>You can set up multiple highlighting boxes per page. To delete a box again, just right-click on it. Once the last box has been deleted, the whole page will become bright and clear again.</p>
<p>If you leave a page that has boxes on it, the boxes will automatically be restored if you re-enter the pager later. By pressing the [S] key, you can even save the box positions to disk and reuse them the next time you start the presentation.</p>
</div>

<div class="feature"><img src="spotlite.png" />
<h2>Spotlight effect</h2>
<p>The highlight boxes are already a nice thing, but there are maybe situations where you want to have a somewhat more &ldquo;dynamic&rdquo; highlighting. So try to press the [Enter] key: a highlighting circle will appear and follow the mouse cursor as you move it.</p>
<p>You can adjust the size of the spotlight using the [+] and [&ndash;] keys.</p>
</div>


</div></body></html>
